package dk.sosi.seal.model;

import dk.sosi.seal.model.constants.*;
import dk.sosi.seal.model.dombuilders.AbstractDOMBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import java.util.List;


public class SubjectRelations10DomBuilder extends AbstractDOMBuilder<Document> implements SubjectRelationsDomBuilder {

    public SubjectRelations10DomBuilder(SubjectRelations subjectRelations) {
        SubjectRelations10Impl subjectRelations10 = (SubjectRelations10Impl)subjectRelations;
        verifiedRelations = subjectRelations10.getVerifiedRelations();
    }

    private final List<SubjectRelations10Impl.VerifiedRelation> verifiedRelations;

    public List<SubjectRelations10Impl.VerifiedRelation> getVerifiedRelations() {
        return verifiedRelations;
    }

    @Override
    public Document build() throws ModelException {
        return createDocument();
    }

    @Override
    protected Element createRoot(Document doc) {
        return createElement(SubjectRelations10Tags.SUBJECT_RELATIONS);
    }

    @Override
    protected void addRootAttributes(Element root) {
        addNS(root, NameSpaces.NS_SRP, NameSpaces.SUBJECT_RELATIONS_PROFILE_1_0);
    }

    @Override
    protected void appendToRoot(Document localDoc, Element root) {
        Element groupElm = createElement(SubjectRelations10Tags.VERIFIED_RELATION);
        for (SubjectRelations10Impl.VerifiedRelation vr : getVerifiedRelations()) {
            groupElm.setAttributeNS(null, "relationType", vr.getRelationType().getValue());
            groupElm.setAttributeNS(null, "relatedPersonID", vr.getRelatedPersonID());
            groupElm.setAttributeNS(null, "relatedPersonIDType", vr.getRelatedPersonIDType().getValue());
            root.appendChild(groupElm);
        }
    }

    @Override
    protected void validateBeforeBuild() throws ModelException {}
}
